/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package myllk;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/**
 *
 * @author cloud
 */
public final class MapUI implements ActionListener {

    Map map;
    Point past;
    Point now;
    JFrame f;

    public MapUI(Map map) {
        this.map = map;
        draw();
    }

    public void draw() {
        f = new JFrame("连连看");
        Container contentPane = f.getContentPane();
        f.setLayout(new GridLayout(Setting.Row, Setting.Col));
        for (int i = 1; i <= Setting.Row; i++) {
            for (int j = 1; j <= Setting.Col; j++) {
                String actionCommand = String.valueOf((i-1) * Setting.Row + j);
                int t = map.getMap()[i][j];
                String text;
                if (t == 0) {
                    text = null;
                } else {
                    text = String.valueOf(t);
                }
                JButton b = new JButton();
                b.setText(text);
                b.addActionListener(this);
                b.setActionCommand(actionCommand);
                contentPane.add(b);
            }
        }
        f.pack();
        f.setTitle("练练看");
        f.setVisible(true);
        f.setSize(400, 400);

        f.addWindowListener(new WindowAdapter() {

            @Override
            public void windowClosing(WindowEvent e) {
                System.exit(0);
            }
        });
    }

    @Override
    public void actionPerformed(ActionEvent ae) {
        int x, y;
        String cmd = ae.getActionCommand();
        int d = Integer.parseInt(cmd);
        x = (d-1) / Setting.Row+1;
        y = d - (x-1) * Setting.Row;
        if (past == null) {
            past = new Point(x, y);
            return;
        }
        now = new Point(x, y);
        if (past.x == x && past.y == y) {
            return;
        } else if (map.canBeRelease(past, now)) {
            map.Release(past, now);
            past = null;
            draw();
        } else {
            past = now;
        }
    }
}
